

kerio = {};
kerio.lib = {
x_a6: 'kerio.lib.js',
x_2o4: '1.2',
x_2o5: 'ExtJS',
x_2o6: '2.0.2',
x_2o7: '../../ext/extjs',
x_2o8: '../../ext/extjsux',
x_2o9: '',
x_2oa: false,
DOM : {
'ELEMENT_NODE'               : 1,
'ATTRIBUTE_NODE'             : 2,
'TEXT_NODE'                  : 3,
'CDATA_SECTION_NODE'         : 4,
'ENTITY_REFERENCE_NODE'      : 5,
'ENTITY_NODE'                : 6,
'PROCESSING_INSTRUCTION_NODE': 7,
'COMMENT_NODE'               : 8,
'DOCUMENT_NODE'              : 9,
'DOCUMENT_TYPE_NODE'         :10,
'DOCUMENT_FRAGMENT_NODE'     :11,
'NOTATION_NODE'              :12
},
x_17: {},
x_2ob: [],  x_2oc: {},
x_6b: {
x_2od:         1,
x_6c:         2,
x_2nj:       3,
x_2oe:      4,
x_1l2:         5,
x_1l4:      6,
x_1mf:         7,
x_2of: 8,
x_2og: 9,
x_2oh: 10,
x_2oi: 11,
x_2oj: 12,
x_1kk: 13,
x_2ok: 14,
x_2ol: 15,
x_1l5: 16,
x_2om: 17,
x_2on: 18,
x_2oo: 19,
x_2op: 21,
x_2oq: 22,
x_2or:     23,
x_2os: 24,
x_2ot: 25,
x_2ou: 27,
x_2ov: 28,
x_2ow: 29,
x_2ox:30,
x_2oy: 31,
x_2oz: 33,
x_2p0: 34,
x_2p1: 35,
x_2p2: 1,
x_2p3: 2,
x_2p4: 3,
x_2p5: 20, x_2p6: 255,
x_2p7: 65536,
x_2p8: 82,
x_2p9: 100,
x_107: false,
x_29k: [],  x_2pa: {
x_1n: 'Please wait…',  x_m2: 250
}
},  x_2pb: 0,
x_2pc: 'x_2pd' + '_',
x_2pe: '%+',
x_2pf: [],
x_2pg: {
x_2ph: new RegExp('"', 'g'),
x_2pi: new RegExp('&', 'g')
},
x_2pj: 30000,

x_2pk: {
x_kq:  'x_2pl',
x_1i:        'x_2pm',
x_pt:      'x_2pn',
x_kt:       'x_2po',
x_rc:        'x_2pp',
x_1q:          'x_ar',
x_7a:             'x_2pq',
x_9u:            'x_a9',
x_2pr:    'x_2ps',
x_b4:            'x_x1',
x_2pt:           'x_2pu',
x_1kd:              'x_2pv',
x_gc:              'x_9b',
x_y7:          'x_2pw',
x_2px:             'x_2py',
x_2pz:      'x_2kb',
x_1g:         'x_2q0',
x_79:          'x_2q1',
x_5x:           'x_2q2',
x_b3:               'x_2q3'
},

x_2q4: false,

x_2q5: {
x_2q6: []
},

x_zz: null,

x_zf : function(x_u6, x_2q7, x_2q8) {
var x_2q9;
if (!x_2q8) {
x_2q9 = this.x_2qa(x_u6, x_2q7);
}
else {
x_2q9 = x_u6;
}
x_2q9 += this.x_2n6;
document.write('<script type="text/javascript" src="' + x_2q9 + '"></script>');
},

x_zg : function(x_u6, x_2q7, x_2q8) {
var x_2q9;
if (!x_2q8) {
x_2q9 = this.x_2qa(x_u6, x_2q7);
}
else {
x_2q9 = x_u6;
}
x_2q9 += this.x_2n6;
var x_js = document.createElement('LINK');
x_js.setAttribute('type', 'text/css');
x_js.setAttribute('rel', 'stylesheet');
x_js.setAttribute('href', x_2q9);
this.x_2qb.appendChild(x_js);
},

x_2qc: function (x_2qd, x_2qe, x_2q7) {
var x_u6,
x_2qf,
x_41,
x_42 = x_2qd.length;
if (!x_2qe) {
x_2qe = './';
}
else if (false === (/^.*\/$/.test(x_2qe))) {
x_2qe += '/';
}
x_2qe = this.x_2qa(x_2qe, x_2q7);
for (x_41 = 0; x_41 < x_42; x_41++) {
x_u6 = x_2qd[x_41];
x_2qf = this.x_2qg(x_u6).toLowerCase();
x_u6 = x_2qe + x_u6;
switch (x_2qf) {
case '.js':
this.x_zf(x_u6, x_2q7, true);
break;
case '.css':
this.x_zg(x_u6, x_2q7, true);
break;
default: kerio.lib.x_nq('Internal error: Unknown file extension \'' + x_2qf + '\'. File: ' + x_u6, 'kLib');
}
}
},

x_2qg: function (x_u6) {
return x_u6.substring(x_u6.lastIndexOf('.'));
},

x_2qa: function(x_u6, x_2q7) {
var x_2q9 = (x_2q7) ? x_u6 : this.x_2o9 + x_u6;
var x_2qh = x_2q9.indexOf('/../');
var x_2qi;
while (-1 != x_2qh && !x_2q7) {
x_2qi = x_2q9.substr(0, x_2qh);
x_2qi = x_2qi.substr(0, x_2qi.lastIndexOf('/'));
x_2q9 = x_2qi + x_2q9.substr(x_2qh + 3);
x_2qh = x_2q9.indexOf('/../');
}
x_2qh = x_2q9.indexOf('://');
if (x_2qh) {
x_2qh += 3;
x_2q9 = x_2q9.substr(0, x_2qh) + x_2q9.substr(x_2qh).replace('//', '/');
}
return x_2q9;
},

x_2qj: function (x_q1, x_1j) {
if (!x_1j) {
x_1j = x_q1.x_1j;
}
if (this.x_17[x_1j]) {
kerio.lib.x_nq('Internal error: Widget ID "' + x_1j + '" already exists.\n' +
'ID has to be unique across the application.', 'kLib.js');
}
this.x_17[x_1j] = x_q1;
},

x_2qk: function(x_1j) {
var x_q1 = this.x_17[x_1j];
var x_2o;
if (x_q1) {
x_2o = x_q1.x_2o;
if (x_2o.destroy) {
x_2o.destroy();
}
else {
delete x_2o;
}
delete this.x_17[x_1j];
}
},

x_1t6: function(x_1j) {
return this.x_17[x_1j];
},

x_2ql : function() {
this.x_2qm();
var x_2qn = document.getElementsByTagName('script');
var x_2o7 = this.x_2o7;
var x_2o8 = this.x_2o8;
var x_2o9;
var x_2qo;
var x_2qp;
var x_2qh;
var x_2qq;
for (var x_41 = 0; x_41 < x_2qn.length; x_41++) {
x_2qo = x_2qn[x_41].src;
if (x_2qo && x_2qo.match(/(.*)\bkLib.js\b/)) {
x_2o9 = RegExp.$1;
if (0 !== x_2o9.indexOf('http') && 0 !== x_2o9.indexOf('/')) {
x_2qp = document.location.href;
x_2qh = x_2qp.lastIndexOf('/');
x_2qp = x_2qp.substr(0, x_2qh + 1);
x_2o9 = this.x_2qa(x_2qp + x_2o9, true);
}
this.x_2o9 = x_2o9;
x_2qh = x_2qo.indexOf('?');
x_2qq = (-1 == x_2qh) ? '' : x_2qo.substr(x_2qh);
if (-1 !== x_2qq.indexOf('x_2qr' )) {
this.x_2q4 = true;
}
this.x_2n6 = x_2qq;
break;
}
}
this.x_2qb = document.getElementsByTagName("head").item(0);
this.x_zg(x_2o7 + '/resources/css/ext-all.css');
if (this.x_2q4) {
this.x_zf(x_2o7 + '/adapter/ext/ext-base-debug.js');
this.x_zf(x_2o7 + '/ext-all-debug.js');
this.x_zf('/weblib/util/internalTools/freshDoc/freshDoc.js', true);
}
else {
this.x_zf(x_2o7 + '/adapter/ext/ext-base.js');
this.x_zf(x_2o7 + '/ext-all.js');
}
this.x_zf (x_2o8 + '/PrinterFriendly/PrinterGridPanel.js');
this.x_zf (x_2o8 + '/PrinterFriendly/PrinterGridView.js');
this.x_zg(x_2o9 + '/kLib.css', true);
this.x_zf (x_2o9 + '/util.js', true);
this.x_zf (x_2o9 + '/core.js', true);
this.x_zf (x_2o9 + '/wrapper.js', true);
if (this.x_2q4) {
this.x_zf(x_2o9 + '/debug/checkTrans.js', true);
}
this.x_2qs();
},

x_2qm: function() {
var x_2qt = navigator.userAgent;
var x_2qu = x_2qt.indexOf('MSIE');
var x_2qv = x_2qt.indexOf('Firefox');
this.x_j9 = (-1 != x_2qu);
this.x_2ny = (-1 != x_2qv);
this.x_1rv = (-1 != x_2qt.indexOf('Safari'));
if (this.x_j9) {
this.x_2qw = 8 == document.documentMode;
this.x_1p3 = !this.x_2qw && (-1 != x_2qt.indexOf('MSIE 7', x_2qu));
this.x_2nx = !this.x_2qw && !this.x_1p3 && (-1 != x_2qt.indexOf('MSIE 6', x_2qu));
if (this.x_2nx && document.documentElement && 'undefined' !== typeof(document.documentElement.style.maxHeight)) {
this.x_2nx = false;
this.x_1p3 = true;
}
}
else {
if (this.x_2ny) {
this.x_2lm = (-1 != x_2qt.indexOf('Firefox/2', x_2qv));
this.x_2qx = !this.x_2lm && (-1 != x_2qt.indexOf('Firefox/3', x_2qv));
}
else {
if (this.x_1rv) {
var x_2qy = new RegExp("\\(.*\\) AppleWebKit/(.*) \\((.*)");
x_2qy = x_2qy.exec(x_2qt);
if (x_2qy) {
x_2qy = parseInt(x_2qy[1].split(".")[0], 10);
}
this.x_2nz = (this.x_1rv && x_2qy > 412 && x_2qy < 420);
this.x_2qz = (this.x_1rv && x_2qy > 419);
}
}
}
}, 
x_2qs: function() {
var
x_2r0 = this.x_2q5.x_2q6,
x_41,
x_42;
if (!window.Ext || !Ext.isReady) {
setTimeout('kerio.lib.x_2qs.call(kerio.lib)', 100);
return;
}
Ext.BLANK_IMAGE_URL = kerio.lib.x_2qa(kerio.lib.x_2o7 + '/s.gif', false);
Ext.QuickTips.init();
this.x_2r1();
this.x_2r2();
if (this.x_2q4) {
for (x_41 = 0, x_42 = x_2r0.length; x_41 < x_42; x_41++) {
x_2r0[x_41]();
}
}
this.x_2r3();
this.x_2r4();
this.x_2r5();
this.x_6t.x_2r6();
this.x_5l.x_m();
this.x_113();
this.x_2oa = true;
if (this.x_zz) {
this.x_zz();
}
}
};

kerio.lib.x_2r7 = function(x_10q, x_2lh)
{
if (undefined === x_2lh) {
if (undefined === x_10q.x_2lh) {
return x_10q;
}
else {
x_2lh = x_10q.x_2lh;    }
}
var x_1b = kerio.lib;
var x_2v;
var x_2r8;
var x_2r9;
var x_2ra;
var x_2rb;
var x_2rc;
var x_2rd;
if (x_10q instanceof Array) {
x_2v = [];
for (var x_41 = 0, x_42 = x_10q.length; x_41 < x_42; x_41++) {
x_2r8 = x_10q[x_41];
if ('string' == typeof(x_2r8) || 'number' == typeof(x_2r8)) {
x_2v.push(x_2r8);
}
else {
if (undefined === x_2r8.x_2lj || x_1b.x_2re(x_2lh, x_2r8.x_2lj)) {
x_2v.push(x_1b.x_2r7(x_2r8, x_2lh));
}
}
}
}
else {
x_2v = {};
if (undefined === x_10q.x_2lj || x_1b.x_2re(x_2lh, x_10q.x_2lj)) {
for (var x_1mc in x_10q) {
x_2r8 = x_10q[x_1mc];
x_2r9 = x_2r8 instanceof Array;
x_2ra = x_2r8 instanceof Object;
x_2rb = x_2r8 instanceof RegExp;
x_2rc = x_2r8 instanceof Function;
x_2rd = (x_2ra && undefined !== x_2r8.x_3h);
if (x_2r9 || (x_2ra && !x_2rb && !x_2rc && !x_2rd)) {
x_2v[x_1mc] = x_1b.x_2r7(x_2r8, x_2lh);
}
else {
x_2v[x_1mc] = x_2r8;
}
}
}
}
return x_2v;
};

kerio.lib.x_2re = function(x_2lh, x_2lj) {
var
x_2rf,
x_2rg,
x_2rh,
x_2ri,
x_2rj,
x_s8;
if ('object' == Ext.type(x_2lh)) {
x_2rf = true === x_2lj.x_2rf;
x_s8 = !x_2rf;
for (x_2rg in x_2lh) {
x_2rh = x_2lh[x_2rg];
x_2ri = x_2lj[x_2rg];
x_2rj = (undefined !== x_2ri) ? (-1 !== x_2ri.indexOf(x_2rh)) : true;
if (x_2rf) {
x_s8 = x_s8 || x_2rj;
}
else {
x_s8 = x_s8 && x_2rj;
}
}
}
else {
x_s8 = (-1 !== x_2lj.indexOf(x_2lh));
}
return x_s8;
};

kerio.lib.x_2rk = function(x_2rl)
{
var x_1f = Ext.type(x_2rl);  if (x_2rl && x_2rl.x_3h) {
x_1f = 'kerioWidget';
}
return ('object' == x_1f || 'array' == x_1f);
};

kerio.lib.x_2rm = function(x_2rn)
{
if (!x_2rn) {
return x_2rn;
}
var x_2ro;
var x_290;
var x_2rp;
var x_1f;
if (x_2rn instanceof Array) {
x_2ro = [];
for (var x_41 = 0, x_42 = x_2rn.length; x_41 < x_42; x_41++) {
x_2rp = x_2rn[x_41];
if (kerio.lib.x_2rk(x_2rp)) {
x_2ro[x_41] = kerio.lib.x_2rm(x_2rp);
}
else {
x_2ro[x_41] = x_2rp;
}
}
}
else {
x_2ro = {};
for (x_290 in x_2rn) {
x_2rp = x_2rn[x_290];
if (undefined !== x_2rp) {
if (kerio.lib.x_2rk(x_2rp)) {
x_2ro[x_290] = kerio.lib.x_2rm(x_2rp);
}
else {
x_2ro[x_290] = x_2rp;
}
}
}
}
return x_2ro;
};

kerio.lib.x_9m = function(x_2rn, x_2rq, x_2v)
{
var
x_1b = kerio.lib,
x_2rr,
x_2ro;
x_2rr = x_1b.x_2rs(x_2v || {}, {
x_2rt: false,
x_2ru          : true,
x_2rv           : true
});
x_2ro = x_1b.x_2rm(x_2rn); 	if (undefined !== x_2rq) {
x_2ro = x_1b.x_2rw(x_2ro, x_2rq, x_2rr);
}
if (true === x_2rr.x_2rt) {
x_2ro = x_1b.x_2rt(x_2ro);
}
return x_2ro;
};

kerio.lib.x_2rw = function (x_rw, x_2rq, x_2v) {
var
x_2ru = x_2v.x_2ru,
x_2rv = x_2v.x_2rv,
x_1b = kerio.lib,
x_290,
x_2rp,
x_2rx,
x_41,
x_42;
if (Ext.isArray(x_2rq)) {
for (x_41 = 0, x_42 = x_2rq.length; x_41 < x_42; x_41++) {
x_2rp = x_rw[x_41];
x_2rx = x_2rq[x_41];
if (x_2ru || (undefined === x_2rp)) {
if (!x_2rv && (undefined === x_2rp)) {
continue;
}
if (x_1b.x_2rk(x_2rx)) {
if (undefined === x_rw[x_290]) {
if (Ext.isArray(x_2rx)) {
x_rw[x_41] = [];
}
else {
x_rw[x_41] = {};
}
}
x_rw[x_41] = x_1b.x_2rw.call(this, x_rw[x_41], x_2rx, x_2v);
}
else {
x_rw[x_41] = x_2rx;
}
}
}
}
else {
for (x_290 in x_2rq) {
x_2rp = x_rw[x_290];
x_2rx = x_2rq[x_290];
if (x_2ru || (undefined === x_2rp)) {
if (!x_2rv && (undefined === x_2rp)) {
continue;
}
if (x_1b.x_2rk(x_2rx)) {
if (undefined === x_rw[x_290]) {
if (Ext.isArray(x_2rx)) {
x_rw[x_290] = [];
}
else {
x_rw[x_290] = {};
}
}
x_rw[x_290] = x_1b.x_2rw.call(this, x_rw[x_290], x_2rx, x_2v);
}
else {
x_rw[x_290] = x_2rx;
}
}
}
}
return x_rw;
};

kerio.lib.x_2rs = function(x_2rn, x_2ry)
{
if (!x_2rn) {
return kerio.lib.x_2rm(x_2ry);
}
var
x_290,
x_2rz,
x_2s0,
x_2s1,
x_2s2,
x_1cl,
x_2s3,
x_2s4,
x_2s5 = kerio.lib.x_2pe,
x_2s6;
for (x_290 in x_2ry) {
x_2rz = x_2ry[x_290];
x_2s0 = x_2rn[x_290];
x_2s1 = Ext.type(x_2rz);
x_2s2 = Ext.type(x_2s0);
if (undefined !== x_2s0 &&  x_2s2 != x_2s1) {
x_2s4 = true;
x_1cl = 'string' == x_2s2 ? x_2s0 : ('string' == x_2s1 ? x_2rz : null);
x_2s3 = 'number' == x_2s2 ? x_2s0 : ('number' == x_2s1 ? x_2rz : null);
if (null !== x_1cl && null !== x_2s3) {
if ('auto' == x_1cl || x_1cl.lastIndexOf('%') == x_1cl.length - 1) {
x_2s4 = false;
}
else if ('value' == x_290) {
x_2s4 = false;
}
}
if (x_2s4) {
kerio.lib.x_nq('Internal error: Type mismatch in x_2rs: ' + x_290, 'kLib.js');
}
}
if (kerio.lib.x_2rk(x_2rz)) {
if (undefined === x_2s0) {
if ('array' == x_2s1) {
x_2rn[x_290] = [];
}
else {
x_2rn[x_290] = {};
}
kerio.lib.x_2rs(x_2rn[x_290], x_2rz);
}
else {
kerio.lib.x_2rs(x_2s0, x_2rz);
}
}
else {
x_2s6 = ('string' == x_2s1) ? x_2rz.indexOf(x_2s5) : -1;
if (undefined === x_2s0 || -1 != x_2s6) {
if (undefined === x_2s0) {
x_2s0 = '';
}
if (-1 != x_2s6) {
x_2rz = x_2rz.replace(x_2s5, x_2s0).trim();
x_2rz = x_2rz.replace('  ', ' ');
}
x_2rn[x_290] = x_2rz;
}
}
}
return x_2rn;
};

kerio.lib.x_2s7 = function(x_2rn, x_jm)
{
if (!x_2rn) {
return x_2rn;
}
var x_290;
var x_2rp;
var x_2s8;
var x_2s9;
var x_2sa;
var x_2sb;
var x_1b = kerio.lib;
if ('array' == Ext.type(x_2rn)) {
x_2s8 = [];
for (var x_41 = 0, x_42 = x_2rn.length; x_41 < x_42; x_41++) {
x_2rp = x_2rn[x_41];
if (kerio.lib.x_2rk(x_2rp)) {
x_2s8[x_41] = x_1b.x_2s7.call(this, x_2rp, x_jm);
}
else {
x_2s8[x_41] = x_2rp;
}
}
}
else {
x_2s8 = {};
for (x_290 in x_2rn) {
x_2rp = x_2rn[x_290];
x_2s9 = x_jm[x_290];
if (x_2s9) {
if ('object' == typeof(x_2s9)) {
kerio.lib.x_2sc.call(this, x_2s8, x_290, x_2rp, x_2s9);
}
else if (kerio.lib.x_2rk(x_2rp)) {
x_2s8[x_2s9] = x_1b.x_2s7.call(this, x_2rp, x_jm);
}
else {
x_2s8[x_2s9] = x_2rp;
}
}
}
}
return x_2s8;
};

kerio.lib.x_2sc = function(x_2s8, x_290, x_2sd, x_2sb) {
var x_1b = kerio.lib,
x_2se = x_1b.x_2sf,
x_2sa = x_2sb.x_2sg,
x_2sh = {};
if (x_2sb.x_rx) {
x_2sh[x_290] = x_2sd;
x_2s8[x_2sa] = x_1b.x_2si.call(this, x_2sb.x_rx);
x_2se(x_2s8, x_2sh);
}
else if (x_2sb.x_2sj) {
if (undefined !== x_2sd) {
if (undefined === x_2s8.listeners) {
x_2s8.listeners = {};
}
x_2sh[x_2sa] = {
fn: x_1b.x_2si.call(this, x_2sb.x_2sj),
scope: x_1b.x_2si.call(this, x_2sb.x_2q)
};
Ext.apply(x_2s8.listeners, x_2sh);
this.x_2sk[x_290] = x_2sd;
}
}
else {
x_1b.x_nq('Internal error: Invalid handlers mapping', 'kLib.js');
}
};

kerio.lib.x_2sl = function(x_2rn, x_2ry, x_jm)
{
var x_2sm;
if (undefined !== x_2rn && 'object' != typeof(x_2rn)) {
return x_2rn;
}
if (x_jm) {
x_2sm = kerio.lib.x_2s7.call(this, x_2rn, x_jm);
}
else {
x_2sm = kerio.lib.x_2rm(x_2rn);
}
if (x_2ry) {
x_2sm = kerio.lib.x_2rs(x_2sm, x_2ry);
}
return x_2sm;
};

kerio.lib.x_2sn = function(x_1j, x_1p)
{
var x_ax = document.getElementById(x_1j);
if (!x_ax) {
x_ax = document.createElement('div');
if (x_1j) {
x_ax.id = x_1j;
}
document.body.appendChild(x_ax);
}
if (x_1p) {
x_ax.className = x_1p;
}
return x_ax;
};

kerio.lib.x_2b8 = function(x_1j)
{
var x_2so = this.x_2oc[x_1j];
if (!x_2so) {
x_2so = document.getElementById(x_1j);
if (x_2so) {
this.x_2oc[x_1j] = x_2so;
}
}
return x_2so;
};

kerio.lib.x_2r1 = function()
{
if ('1.0.1' == this.x_2o6) {
Ext.Toolbar.prototype.addFill = function() {
return this.addItem(new Ext.Toolbar.Fill());
};
Ext.Toolbar.Fill = Ext.extend(Ext.Toolbar.Spacer, {
render : function(td){
td.style.width = '100%';
Ext.Toolbar.Fill.superclass.render.call(this, td);
}
});
} if ('1.1.1' == this.x_2o6) {

Ext.Button.prototype.disable = function() {
if (this.el) {
this.el.addClass("x-btn-disabled");
if (Ext.isIE) {
this.el.child('button').dom.disabled = true;
}
}
this.disabled = true;
};
Ext.Button.prototype.enable = function() {
if (this.el) {
this.el.removeClass("x-btn-disabled");
if (Ext.isIE) {
this.el.child('button').dom.disabled = false;
}
}
this.disabled = false;
};
Ext.Toolbar.Button.prototype.disable = function() {
Ext.fly(this.td).addClass("x-item-disabled");
if (Ext.isIE) {
this.el.child('button').dom.disabled = true;
}
this.disabled = true;
};
Ext.Toolbar.Button.prototype.enable = function() {
Ext.fly(this.td).removeClass("x-item-disabled");
if (Ext.isIE) {
this.el.child('button').dom.disabled = false;
}
this.disabled = false;
};
Ext.form.ComboBox.prototype.onResize = function(w, h) {
Ext.form.ComboBox.superclass.onResize.apply(this, arguments);
if(this.list && this.listWidth === undefined){
var lw = Math.max(w, this.minListWidth);
if (isNaN(lw)) {
lw = this.minListWidth;
}
this.list.setWidth(lw);
this.innerList.setWidth(lw - this.list.getFrameWidth('lr'));
}
}; 
Ext.grid.RowSelectionModel.prototype.handleMouseDown = function(e, t) {
var view = this.grid.getView(), rowIndex;
if(this.isLocked() || (rowIndex = view.findRowIndex(t)) === false) {
return;
}
if(e.shiftKey && this.last !== false) {
var last = this.last;
this.selectRange(last, rowIndex, e.ctrlKey);
this.last = last;
view.focusRow(rowIndex);
}
else {
var isSelected = this.isSelected(rowIndex);
if(e.button !== 0 && isSelected) {
view.focusRow(rowIndex);
}
else
if(e.ctrlKey && isSelected) {
this.deselectRow(rowIndex);
}
else
if(!isSelected || this.getCount() > 1) {
this.selectRow(rowIndex, e.ctrlKey || e.shiftKey);
view.focusRow(rowIndex);
}
}
}; } if ('2.0.2' == this.x_2o6) {

Ext.Tip.prototype.showAt = function(x_2sp){
Ext.Tip.superclass.show.call(this);
if(this.measureWidth !== false && (!this.initialConfig || typeof this.initialConfig.width != 'number')){
var x_2sq = this.body.getTextWidth();
if(this.title){
x_2sq = Math.max(x_2sq, this.header.child('span').getTextWidth(this.title));
}
x_2sq += this.getFrameWidth() + (this.closable ? 20 : 0) + this.body.getPadding("lr");
this.setWidth(x_2sq.constrain(this.minWidth, this.maxWidth));
}
if(this.constrainPosition){
x_2sp = this.el.adjustForConstraints(x_2sp);
}
this.setPagePosition(x_2sp[0], x_2sp[1]);
if(Ext.isIE7 && !this.repainted){ this.el.repaint();
this.repainted = true;
}
};

Ext.EventObjectImpl.prototype.isSpecialKey = function () {
var safariKeys = {
63234 : 37, 63235 : 39, 63232 : 38, 63233 : 40, 63276 : 33, 63277 : 34, 63272 : 46, 63273 : 36, 63275 : 35  };
var k = this.keyCode;
return (this.type == 'keypress' && this.ctrlKey) || k == 9 || k == 13  || k == 40 || k == 27 ||
(k == 16) || (k == 17) ||
(k >= 18 && k <= 20) ||
(k >= 33 && k <= 35) ||
(k >= 36 && k <= 39) ||
(k >= 44 && k <= 45);
};

Ext.form.NumberField.prototype.initEvents = function() {
Ext.form.NumberField.superclass.initEvents.call(this);
var allowed = this.baseChars + '';
if (this.allowDecimals) {
allowed += this.decimalSeparator;
}
if (this.allowNegative) {
allowed += "-";
}
this.stripCharsRe = new RegExp('[^' + allowed + ']', 'gi');

kerio.lib.x_2sf(this, {x_2sr: allowed});
var keyPress = function(e){
var k = e.getKey(),
allowed = this._kx.x_2sr;
var x_2ss = (!Ext.isIE) ? ((k == e.DELETE) && (0 == e.charCode)) : (k == e.DELETE);
if (!Ext.isIE && (e.isSpecialKey() || k == e.BACKSPACE || x_2ss)) {
return;
}
var c = e.getCharCode();
if (allowed.indexOf(String.fromCharCode(c)) === -1) {
e.stopEvent();
}
};
this.el.on("keypress", keyPress, this);
};

Ext.PagingToolbar.prototype.onRender = function(ct, position) {
Ext.PagingToolbar.superclass.onRender.call(this, ct, position);
this.first = this.addButton({
tooltip: this.firstText,
iconCls: "x-tbar-page-first",
disabled: true,
handler: this.onClick.createDelegate(this, ["first"])
});
this.prev = this.addButton({
tooltip: this.prevText,
iconCls: "x-tbar-page-prev",
disabled: true,
handler: this.onClick.createDelegate(this, ["prev"])
});
this.addSeparator();
this.add(this.beforePageText);
var x_2st = new Ext.form.NumberField({
allowNegative: false,
allowDecimals: false,
value: '1',
focusClass: '',
emptyClass: '',
disabledClass: ''
});
this.addField(x_2st);
this.field = x_2st.getEl();
this.field.dom.size = 3;
this.field.dom.className = 'x-tbar-page-number';
this.field.on("keydown", this.onPagingKeydown, this);
this.field.on("focus", function(){this.dom.select();});
this.afterTextEl = this.addText(String.format(this.afterPageText, 1));
this.field.setHeight(18);
this.addSeparator();
this.next = this.addButton({
tooltip: this.nextText,
iconCls: "x-tbar-page-next",
disabled: true,
handler: this.onClick.createDelegate(this, ["next"])
});
this.last = this.addButton({
tooltip: this.lastText,
iconCls: "x-tbar-page-last",
disabled: true,
handler: this.onClick.createDelegate(this, ["last"])
});
this.addSeparator();
this.loading = this.addButton({
tooltip: this.refreshText,
iconCls: "x-tbar-loading",
handler: this.onClick.createDelegate(this, ["refresh"])
});
if(this.displayInfo){
this.displayEl = Ext.fly(this.el.dom).createChild({cls:'x-paging-info'});
}
if(this.dsLoaded){
this.onLoad.apply(this, this.dsLoaded);
}
};	
Ext.LoadMask.prototype.onLoad = function () {
if (!this.disabled) {
this.el.unmask(this.removeMask);
}
};

Ext.grid.GridView.prototype.autoExpand = function(preventUpdate){
var g = this.grid, cm = this.cm;
if (!this.userResized && (false !== g.autoExpandColumn)) {
var tw = cm.getTotalWidth(false);
var aw = this.grid.getGridEl().getWidth(true) - this.scrollOffset;
if (tw != aw) {
var ci = cm.getIndexById(g.autoExpandColumn);
var currentWidth = cm.getColumnWidth(ci);
var cw = Math.min(Math.max(((aw - tw) + currentWidth), g.autoExpandMin), g.autoExpandMax);
if (cw != currentWidth) {
cm.setColumnWidth(ci, cw, true);
if (preventUpdate !== true) {
this.updateColumnWidth(ci, cw);
}
}
}
}
}; 
Ext.grid.GridView.prototype.render = function(){
var cm = this.cm;
var colCount = cm.getColumnCount();
if(this.autoFill){
this.fitColumns(true, true);
}else if(this.forceFit){
this.fitColumns(true, false);
}else if(false !== this.grid.autoExpandColumn){
this.autoExpand(true);
}
this.renderUI();
}; 
Ext.grid.GridView.prototype._kxp = Ext.apply({}, Ext.grid.GridView.prototype._kxp, {
x_2su: Ext.grid.GridView.prototype.ensureVisible
});
Ext.grid.GridView.prototype.ensureVisible = function(row, col, hscroll) {
row = Math.min(row, Math.max(0, this.getRows().length-1));
var xy = this._kxp.x_2su.call(this, row, col, hscroll);
if(hscroll === false && col === 0) {
xy[0] += this.el.getX();
}
xy = xy||this.scroller.getXY();
return xy;
};

Ext.MessageBox.updateText = Ext.MessageBox.updateText.createSequence(function () {
if (Ext.isGecko) {
var x_16 = this.getDialog();
var x_2n = x_16.getSize();
x_16.setSize(x_2n.width + 1, 'auto').center();
}
});

Ext.form.TriggerField.prototype.initTrigger = Ext.form.TriggerField.prototype.initTrigger.createSequence(function () {
if (!this.hideTrigger) {
this.trigger.getWidth = Ext.Element.prototype.getComputedWidth;
}
if (!Ext.isIE) { this.el.getWidth = Ext.Element.prototype.getComputedWidth;
}
});

Ext.override(Ext.grid.GridView, {
getEditorParent: function(ed) {
return this.mainWrap.dom;
}
});

Ext.MessageBox.setIcon = Ext.MessageBox.setIcon.createSequence(function () {
var
x_2sv = this.getDialog().body.dom.firstChild,
x_2sw = Ext.get(x_2sv.firstChild),
x_2sx = Ext.get(x_2sv.childNodes[1]);
if (!x_2sw.hasClass('x-hidden')) {
x_2sx.addClass('messageBoxWithIcon');
}
else {
x_2sx.removeClass('messageBoxWithIcon');
}
});

if (Ext.isIE) { Ext.menu.Menu.prototype.autoWidth = function() {
var el = this.el, ul = this.ul;
if(!el){
return;
}
var w = this.width;
if(w){
el.setWidth(w);
}
};

Ext.form.Field.prototype.adjustWidth = function(tag, w){
var ownerCt;
tag = tag.toLowerCase();
if(typeof w == 'number' && !Ext.isSafari){
if(Ext.isIE && (tag == 'input' || tag == 'textarea')){
if(tag == 'input' && !Ext.isStrict){
return this.inEditor ? w : w - 3;
}
if(tag == 'input' && Ext.isStrict){
ownerCt = this.ownerCt ? this.ownerCt.ownerCt : null;
if (!ownerCt || !(ownerCt.layout instanceof Ext.layout.ColumnLayout) || undefined !== this.initialConfig.width) {
w -= 1;
}
return w;
}
if(tag == 'textarea' && Ext.isStrict){
return w-2;
}
}else if(Ext.isOpera && Ext.isStrict){
if(tag == 'input'){
return w + 2;
}
if(tag == 'textarea'){
return w-2;
}
}
}
return w;
};
}
if (Ext.isSafari3) {
Ext.KeyNav.prototype.enable = function(){
if (this.disabled) {
this.el.on('keydown', this.relay, this);
this.disabled = false;
}
};
Ext.KeyNav.prototype.disable = function(){
if (!this.disabled) {
this.el.un('keydown', this.relay);
this.disabled = true;
}
};
Ext.form.Field.prototype.initEvents = Ext.form.Field.prototype.initEvents.createSequence(function(){
this.el.un('keypress', this.fireKey, this);
this.el.on('keydown', this.fireKey, this);
});
} if (Ext.isGecko) {

Ext.grid.GridView.prototype.renderUI = Ext.grid.GridView.prototype.renderUI.createSequence(function(){
var x_3l = this.grid;
if (x_3l.trackMouseOver) {
x_3l.un('mouseover', this.onRowOver, this);
x_3l.un('mouseout', this.onRowOut, this);
this.mainBody.on('mouseover', this.onRowOver, this);
this.mainBody.on('mouseout', this.onRowOut, this);
}
});
Ext.grid.GridView.prototype.onRowOut = function(e, t){
var row;
if ((row = this.findRowIndex(t)) !== false && !e.within(this.getRow(row), true)) {
this.removeRowClass(row, 'x-grid3-row-over');
}
}; 
Ext.lib.Event.resolveTextNode = Ext.isGecko ? function(node){
if(!node){
return;
}
var s = HTMLElement.prototype.toString.call(node);
if(s == '[xpconnect wrapped native prototype]' || s == '[object XULElement]'){
return;
}
return node.nodeType == 3 ? node.parentNode : node;
} : function(node){
return node && node.nodeType == 3 ? node.parentNode : node;
};
}
} }; 
kerio.lib.x_6o = function(x_1oa, x_2sy, x_2al) {
if (undefined === x_2al) {
x_2al = kerio.lib.x_6b.x_6d.x_6e.x_1gd;
}
if (!x_1oa.x_2sz) {
x_1oa.x_2sz = [];
}
if (!(x_2al instanceof Array)) {
x_2al = [x_2al];
}
var x_2sz = x_1oa.x_2sz;
var x_2t0;
for (var x_41 = 0, x_42 = x_2al.length; x_41 < x_42; x_41++) {
x_2t0 = x_2al[x_41];
if (!x_2sz[x_2t0]) {
x_2sz[x_2t0] = [];
}
x_1oa.x_2sz[x_2t0].push(x_2sy);
}
}; 
kerio.lib.x_2t1 = function() {
}; 
kerio.lib.x_2t2 = function(x_4d, x_2al, x_96) {
x_96 = x_96 || {};
var x_1b = kerio.lib;
var x_4e = new x_1b.x_2t3(x_2al, x_96);
var x_2sz = x_4d.x_2sz;
if (!x_2sz) {
return;
}
if (!x_2al) {
x_1b.x_nq('Internal error: kerio.lib.x_2t2: unspecified event type!', 'kLib.js');
return;
}
var x_2t4 = x_1b.x_6b.x_6d.x_6e.x_1gd;
if (x_2t4 === x_2al) {
x_1b.x_nq('Internal error: kerio.lib.x_2t2: event type cannot be x_6d.x_6e.x_1gd!', 'kLib.js');
return;
}
var x_2t5;
if (x_2sz[x_2t4] && x_2sz[x_2al]) {
x_2t5 = x_2sz[x_2t4].concat(x_2sz[x_2al]);
}
else {
x_2t5 = x_2sz[x_2t4] || x_2sz[x_2al];
}
if (x_2t5) {
for (var x_41 = 0, x_42 = x_2t5.length; x_41 < x_42; x_41++) {
x_2t5[x_41].x_4c.call(x_2t5[x_41], x_4d, x_4e);
}
}
}; 
kerio.lib.x_48 = function(x_1y, x_2ng, x_2e, x_2q) {

if (undefined === x_2e) {
x_2e = kerio.lib.x_2t6;
}
else {
x_2e = x_2e.createSequence(kerio.lib.x_2t6);
}
kerio.lib.x_2pf.push({
x_1y   : x_1y,
x_2ng     : x_2ng,
x_2e: x_2e,
x_2q   : x_2q
});
if (kerio.lib.x_2pf.length == 1) {
kerio.lib.x_2t7();
}
};

kerio.lib.x_2t7 = function() {
var x_2t8 = kerio.lib.x_2pf,
x_2t9,
x_2e;
if (x_2t8.length > 0) {
x_2t9 = x_2t8[0];
x_2e = x_2t9.x_2e.createSequence(kerio.lib.x_2t7);
Ext.Msg.alert(x_2t9.x_1y, x_2t9.x_2ng, x_2e, x_2t9.x_2q);
}
};

kerio.lib.x_2t6 = function() {
kerio.lib.x_2pf.shift();
};

kerio.lib.x_2r5 = function () {
var x_2ta = Ext.Msg.getDialog(),
x_2tb = x_2ta.manager,
x_2tc = new Ext.WindowGroup();
x_2tc.zseed = this.x_2pj;
x_2tb.unregister(x_2ta);
x_2ta.manager = x_2tc;
x_2tc.register(x_2ta);
};

kerio.lib.x_4b = function(x_1y, x_2ng, x_74, x_2q, x_2td) {
x_2ng = kerio.lib.x_2te(x_2ng);
kerio.lib.x_2sf(Ext.Msg.getDialog(), {x_2td: x_2td});
Ext.Msg.confirm(x_1y, x_2ng, x_74, x_2q);
};

kerio.lib.x_36 = function(x_2tf, x_2tg, x_2th) {
Ext.extend(x_2tf, x_2tg, x_2th);
};

kerio.lib.x_2ti = function(x_2tj) {
var x_6v = null;
try {
x_6v = Ext.util.JSON.decode(x_2tj);
}
catch (x_2tk) {
}
return x_6v;
};

kerio.lib.x_6r = function(x_rw) {
return Ext.util.JSON.encode(x_rw);
};

kerio.lib.x_2tl = function() {
return this.x_2pc + (this.x_2pb++);
};

kerio.lib.x_qc = function(x_2tm) {
return Ext.util.Format.htmlEncode(x_2tm);
};

kerio.lib.x_102 = function(x_6b) {
if (!kerio.lib.x_1j1) {
kerio.lib.x_1j1 = {};
}
Ext.apply(kerio.lib.x_1j1, x_6b);
};

kerio.lib.x_2sf = function(x_2o, x_rw) {
if (!x_2o._kx) {
x_2o._kx = {};
}
Ext.apply(x_2o._kx, x_rw);
};

kerio.lib.x_2tn = function(x_q1) {
return (x_q1 instanceof kerio.lib.x_1md);
};

kerio.lib.x_2te = function (x_2tm, x_2to) {
var x_2tp = x_2tm.split(/\b|\s/);
x_2to = x_2to || 50;
var x_2tq;
for (var x_41=0, x_42=x_2tp.length; x_41<x_42; x_41++) {
x_2tq = x_2tp[x_41];
if (x_2tq.length > x_2to) {
x_2tm = x_2tm.replace(x_2tq, Ext.util.Format.ellipsis(x_2tq, x_2to));
}
}
return x_2tm;
};

kerio.lib.x_2tr = function (x_2tm, x_1u9) {
return Ext.util.Format.ellipsis(x_2tm, x_1u9);
};

kerio.lib.x_2r4 = function () {
var x_2ts = new Ext.Window({
draggable: true,
modal: false,
resizable: true,
width: 1,
height: 1,
pageX: -1000,
pageY: -1000,
listeners: {
'show': function (x_2ta) {
x_2ta.close();
}
}
});
x_2ts.show();
};

kerio.lib.x_nq = function(x_1n, x_5g, x_2tt) {
if (undefined === x_2tt) {
x_2tt = 'N/A';
}
if (window.onerror) {
if (x_5g.lastIndexOf('.js') != x_5g.length - 3) {
x_5g += '.js';
}
x_5g = document.location.protocol + '//' +document.location.host + '/' + x_5g;
window.onerror(x_1n, x_5g, x_2tt);
}
else {
throw x_1n + ' [' + x_5g + ':' + x_2tt + ']';
}
};

kerio.lib.x_2ag = function(x_2tu) {
kerio.lib.x_2tv = x_2tu;
};

kerio.lib.x_2si = function(x_2tw) {
var x_1an = x_2tw.split('.'),
x_42 = x_1an.length,
x_2tx,
x_41;
if (x_42 < 1) {
return null;
}
x_2tx = ('this' == x_1an[0]) ? this : x_2tx = kerio.lib[x_1an[0]];
for (x_41 = 1; x_41 < x_42; x_41++) {
x_2tx = x_2tx[x_1an[x_41]];
}
return x_2tx;
};

kerio.lib.x_2ty = function(x_gc, x_ke) {
var x_2tz = kerio.lib.x_2pg;
if (!x_ke) {
x_gc = Ext.util.Format.htmlEncode(x_gc);
}
else {
x_gc = x_gc.replace(x_2tz.x_2ph, '&quot;');
}
x_gc = x_gc.replace(x_2tz.x_2pi, '&amp;');
return ' ext:qtip="' + x_gc + '"';
};

kerio.lib.x_2u0 = function(x_2u1, x_1p) {
if (undefined === x_2u1) {
return x_1p;
}
if (-1 == x_2u1.indexOf(x_1p)) {
x_2u1 = '' == x_2u1 ? x_1p : x_2u1 + ' ' + x_1p;
}
return x_2u1;
};

kerio.lib.x_2u2 = function(x_2u1, x_1p) {
if (undefined === x_2u1) {
return '';
}
if (-1 != x_2u1.indexOf(x_1p)) {
x_2u1 = x_2u1.replace(x_1p, '');
x_2u1 = x_2u1.replace('  ', ' ');
}
return x_2u1;
};

kerio.lib.x_2u3 = function (x_96) {
var x_2u4 = (0 === x_96.button);
if (Ext.isIE && -1 == x_96.button && 0 == x_96.browserEvent.button && 'dblclick' == x_96.type) {
x_2u4 = true;
}
if ((true === Ext.isMac) && x_2u4) {
x_2u4 = (true !== x_96.ctrlKey);
}
return !x_2u4;
};

kerio.lib.x_2u5 = function (x_1vz) {
var x_1b = kerio.lib,
x_2u6;
x_2u6 = x_1b[x_1b.x_2pk[x_1vz]];
if (undefined === x_2u6) {
kerio.lib.x_nq('Internal error: undefined constructor for item type ' + x_1vz, 'kLib.js');
}
return x_2u6;
};

kerio.lib.x_2rt = function (x_2rn) {
if (!x_2rn) {
return;
}
var x_290;
var x_2rp;
if (x_2rn instanceof Array) {
for (var x_41 = 0, x_42 = x_2rn.length; x_41 < x_42; x_41++) {
x_2rp = x_2rn[x_41];
if (undefined === x_2rp) {
x_2rn.splice(x_41, 1);
}
else if (kerio.lib.x_2rk(x_2rp)) {
kerio.lib.x_2rt(x_2rp);
}
}
}
else {
for (x_290 in x_2rn) {
x_2rp = x_2rn[x_290];
if (undefined === x_2rp) {
delete x_2rn[x_290];
}
else if (kerio.lib.x_2rk(x_2rp)) {
kerio.lib.x_2rt(x_2rp);
}
}
}
return x_2rn;
};

kerio.lib.x_2u7 = function(x_2u8) {
var
x_2u9,
x_1u9 = x_2u8.length,
x_2ua = 0,
x_41;
for (x_41 = 0; x_41 < x_1u9; x_41++) {
x_2u9 = x_2u8.charCodeAt(x_41);
if (0x80 > x_2u9) { x_2ua += 1; continue;
}
if (0x800 > x_2u9) { x_2ua += 2;
continue;
}
x_2ua += 3;
}
return x_2ua;
};

kerio.lib.x_2ub = function(x_2u8, x_1ct, x_2uc) {
var
x_2u9,
x_1u9 = x_2u8.length,
x_2ud = 0,
x_2ue = '', x_41, x_2uf;
x_1ct = x_1ct || 0;
x_2uc = x_2uc || (0 === x_2uc ? 0 : Number.MAX_VALUE);
if (x_1ct >= x_2uc) {
return ''; }
for (x_41 = 0; x_41 < x_1u9; x_41++, x_2ud += x_2uf) {
x_2u9 = x_2u8.charCodeAt(x_41);
if (0x80 > x_2u9) { x_2uf = 1; }
else if (0x800 > x_2u9) { x_2uf = 2;
}
else { x_2uf = 3;
}
if (x_2ud >= x_1ct) {
if ((x_2ud + x_2uf) > x_2uc) {
return x_2ue; }
x_2ue += x_2u8.charAt(x_41);
}
}
return x_2ue;
};

kerio.lib.x_2ug = function(x_2uh, x_2ui) {
return x_2uh - x_2ui;
};

kerio.lib.x_2r3 = function () {
var
x_ax,
x_2uj;
if (!this.x_2uk) {
x_ax = document.createElement('div');
x_2uj = document.createElement('div');
x_ax.style.width = '100px';
x_ax.style.height = '100px';
x_ax.style.position = 'absolute';
x_ax.style.top = '-100000px';
x_ax.style.left = '-100000px';
x_ax.style.overflow = 'scroll';
x_2uj.style.height = '200px';
x_2uj.style.width = '200px';
x_ax.appendChild(x_2uj);
document.body.appendChild(x_ax);
this.x_2uk = x_ax;
}
};

kerio.lib.x_2ul = function () {
if (undefined !== this.x_2um) {
return this.x_2um;
}
this.x_2um = {
x_1u: 100 - this.x_2uk.clientWidth,
x_1v: 100 - this.x_2uk.clientHeight
};
return this.x_2um;
};

kerio.lib.x_2r2 = function () {
if (true !== kerio.lib.x_2qw) {
return;
}
var x_2nv = Ext.getBody();
x_2nv.removeClass('ext-ie6');
x_2nv.removeClass('ext-ie7');
Ext.isIE6 = false;
Ext.isIE7 = false;
};

kerio.lib.x_1k8 = function(x_q1, x_2v) {
var
x_2un = x_q1.x_2o.getEl(),
x_2uo;
x_2v = kerio.lib.x_2sl(x_2v, kerio.lib.x_6b.x_2pa);
x_2uo = x_2un.mask();
x_2uo.addClass('invisible');
kerio.lib.x_2up.defer(x_2v.x_m2, kerio.lib, [x_2un, x_2v.x_1n]);
};

kerio.lib.x_2up = function(x_2un, x_1n) {
if (x_2un.isMasked()) {
x_2un.mask(x_1n);
}
};

kerio.lib.x_1k9 = function(x_q1) {
var	x_2un = x_q1.x_2o.getEl();
x_2un.unmask();
};

kerio.lib.x_1k7 = function() {
return kerio.lib.x_2uq.x_2a5;
}

kerio.lib.x_2ql();